'use strict';

/* jshint ignore:start */
/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */
/* jshint ignore:end */

var Q = require('q');  /* jshint ignore:line */
var _ = require('lodash');  /* jshint ignore:line */
var util = require('util');  /* jshint ignore:line */
var Page = require('../../../../../base/Page');  /* jshint ignore:line */
var deserialize = require(
    '../../../../../base/deserialize');  /* jshint ignore:line */
var serialize = require(
    '../../../../../base/serialize');  /* jshint ignore:line */
var values = require('../../../../../base/values');  /* jshint ignore:line */

var ImpressionsRateList;
var ImpressionsRatePage;
var ImpressionsRateInstance;
var ImpressionsRateContext;

/* jshint ignore:start */
/**
 * Initialize the ImpressionsRateList
 *
 * PLEASE NOTE that this class contains preview products that are subject to
 * change. Use them with caution. If you currently do not have developer preview
 * access, please contact help@twilio.com.
 *
 * @constructor Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateList
 *
 * @param {Twilio.Preview.TrustedComms} version - Version of the resource
 * @param {string} businessSid - A string that uniquely identifies this Business.
 */
/* jshint ignore:end */
ImpressionsRateList = function ImpressionsRateList(version, businessSid) {
  /* jshint ignore:start */
  /**
   * @function impressionsRate
   * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext#
   *
   * @param {string} sid - sid of instance
   *
   * @returns {Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateContext}
   */
  /* jshint ignore:end */
  function ImpressionsRateListInstance(sid) {
    return ImpressionsRateListInstance.get(sid);
  }

  ImpressionsRateListInstance._version = version;
  // Path Solution
  ImpressionsRateListInstance._solution = {businessSid: businessSid};
  /* jshint ignore:start */
  /**
   * Constructs a impressions_rate
   *
   * @function get
   * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateList#
   *
   * @returns {Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateContext}
   */
  /* jshint ignore:end */
  ImpressionsRateListInstance.get = function get() {
    return new ImpressionsRateContext(this._version, this._solution.businessSid);
  };

  /* jshint ignore:start */
  /**
   * Provide a user-friendly representation
   *
   * @function toJSON
   * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateList#
   *
   * @returns Object
   */
  /* jshint ignore:end */
  ImpressionsRateListInstance.toJSON = function toJSON() {
    return this._solution;
  };

  ImpressionsRateListInstance[util.inspect.custom] = function inspect(depth,
      options) {
    return util.inspect(this.toJSON(), options);
  };

  return ImpressionsRateListInstance;
};


/* jshint ignore:start */
/**
 * Initialize the ImpressionsRatePage
 *
 * PLEASE NOTE that this class contains preview products that are subject to
 * change. Use them with caution. If you currently do not have developer preview
 * access, please contact help@twilio.com.
 *
 * @constructor Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRatePage
 *
 * @param {TrustedComms} version - Version of the resource
 * @param {Response<string>} response - Response from the API
 * @param {ImpressionsRateSolution} solution - Path solution
 *
 * @returns ImpressionsRatePage
 */
/* jshint ignore:end */
ImpressionsRatePage = function ImpressionsRatePage(version, response, solution)
                                                    {
  // Path Solution
  this._solution = solution;

  Page.prototype.constructor.call(this, version, response, this._solution);
};

_.extend(ImpressionsRatePage.prototype, Page.prototype);
ImpressionsRatePage.prototype.constructor = ImpressionsRatePage;

/* jshint ignore:start */
/**
 * Build an instance of ImpressionsRateInstance
 *
 * @function getInstance
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRatePage#
 *
 * @param {ImpressionsRatePayload} payload - Payload response from the API
 *
 * @returns ImpressionsRateInstance
 */
/* jshint ignore:end */
ImpressionsRatePage.prototype.getInstance = function getInstance(payload) {
  return new ImpressionsRateInstance(this._version, payload, this._solution.businessSid);
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRatePage#
 *
 * @returns Object
 */
/* jshint ignore:end */
ImpressionsRatePage.prototype.toJSON = function toJSON() {
  let clone = {};
  _.forOwn(this, function(value, key) {
    if (!_.startsWith(key, '_') && ! _.isFunction(value)) {
      clone[key] = value;
    }
  });
  return clone;
};

ImpressionsRatePage.prototype[util.inspect.custom] = function inspect(depth,
    options) {
  return util.inspect(this.toJSON(), options);
};


/* jshint ignore:start */
/**
 * Initialize the ImpressionsRateContext
 *
 * PLEASE NOTE that this class contains preview products that are subject to
 * change. Use them with caution. If you currently do not have developer preview
 * access, please contact help@twilio.com.
 *
 * @constructor Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateInstance
 *
 * @property {string} accountSid - Account Sid.
 * @property {string} businessSid - Business Sid.
 * @property {Date} end - The end date that for this Impressions Rate.
 * @property {impressions_rate.intervals} interval -
 *          The Interval of this Impressions Rate.
 * @property {object} reports - Values of Impressions Rate per interval.
 * @property {Date} start - The start date that for this Impressions Rate.
 * @property {string} url - The URL of this resource.
 *
 * @param {TrustedComms} version - Version of the resource
 * @param {ImpressionsRatePayload} payload - The instance payload
 * @param {sid} businessSid - A string that uniquely identifies this Business.
 */
/* jshint ignore:end */
ImpressionsRateInstance = function ImpressionsRateInstance(version, payload,
                                                            businessSid) {
  this._version = version;

  // Marshaled Properties
  this.accountSid = payload.account_sid; // jshint ignore:line
  this.businessSid = payload.business_sid; // jshint ignore:line
  this.end = deserialize.iso8601DateTime(payload.end); // jshint ignore:line
  this.interval = payload.interval; // jshint ignore:line
  this.reports = payload.reports; // jshint ignore:line
  this.start = deserialize.iso8601DateTime(payload.start); // jshint ignore:line
  this.url = payload.url; // jshint ignore:line

  // Context
  this._context = undefined;
  this._solution = {businessSid: businessSid, };
};

Object.defineProperty(ImpressionsRateInstance.prototype,
  '_proxy', {
    get: function() {
      if (!this._context) {
        this._context = new ImpressionsRateContext(this._version, this._solution.businessSid);
      }

      return this._context;
    }
});

/* jshint ignore:start */
/**
 * fetch a ImpressionsRateInstance
 *
 * @function fetch
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateInstance#
 *
 * @param {object} [opts] - Options for request
 * @param {string} [opts.brandSid] - Brand Sid.
 * @param {string} [opts.brandedChannelSid] - Branded Channel Sid.
 * @param {string} [opts.phoneNumberSid] - Phone Number Sid.
 * @param {string} [opts.country] - Country 2-letter ISO 3166 code.
 * @param {Date} [opts.start] - The start date that for this Impressions Rate.
 * @param {Date} [opts.end] - The end date that for this Impressions Rate.
 * @param {impressions_rate.intervals} [opts.interval] -
 *          The Interval of this Impressions Rate.
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed ImpressionsRateInstance
 */
/* jshint ignore:end */
ImpressionsRateInstance.prototype.fetch = function fetch(opts, callback) {
  return this._proxy.fetch(opts, callback);
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateInstance#
 *
 * @returns Object
 */
/* jshint ignore:end */
ImpressionsRateInstance.prototype.toJSON = function toJSON() {
  let clone = {};
  _.forOwn(this, function(value, key) {
    if (!_.startsWith(key, '_') && ! _.isFunction(value)) {
      clone[key] = value;
    }
  });
  return clone;
};

ImpressionsRateInstance.prototype[util.inspect.custom] = function inspect(depth,
    options) {
  return util.inspect(this.toJSON(), options);
};


/* jshint ignore:start */
/**
 * Initialize the ImpressionsRateContext
 *
 * PLEASE NOTE that this class contains preview products that are subject to
 * change. Use them with caution. If you currently do not have developer preview
 * access, please contact help@twilio.com.
 *
 * @constructor Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateContext
 *
 * @param {TrustedComms} version - Version of the resource
 * @param {sid} businessSid - Business Sid.
 */
/* jshint ignore:end */
ImpressionsRateContext = function ImpressionsRateContext(version, businessSid) {
  this._version = version;

  // Path Solution
  this._solution = {businessSid: businessSid, };
  this._uri = `/Businesses/${businessSid}/Insights/ImpressionsRate`;
};

/* jshint ignore:start */
/**
 * fetch a ImpressionsRateInstance
 *
 * @function fetch
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateContext#
 *
 * @param {object} [opts] - Options for request
 * @param {string} [opts.brandSid] - Brand Sid.
 * @param {string} [opts.brandedChannelSid] - Branded Channel Sid.
 * @param {string} [opts.phoneNumberSid] - Phone Number Sid.
 * @param {string} [opts.country] - Country 2-letter ISO 3166 code.
 * @param {Date} [opts.start] - The start date that for this Impressions Rate.
 * @param {Date} [opts.end] - The end date that for this Impressions Rate.
 * @param {impressions_rate.intervals} [opts.interval] -
 *          The Interval of this Impressions Rate.
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed ImpressionsRateInstance
 */
/* jshint ignore:end */
ImpressionsRateContext.prototype.fetch = function fetch(opts, callback) {
  if (_.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  opts = opts || {};

  var deferred = Q.defer();
  var data = values.of({
    'BrandSid': _.get(opts, 'brandSid'),
    'BrandedChannelSid': _.get(opts, 'brandedChannelSid'),
    'PhoneNumberSid': _.get(opts, 'phoneNumberSid'),
    'Country': _.get(opts, 'country'),
    'Start': serialize.iso8601DateTime(_.get(opts, 'start')),
    'End': serialize.iso8601DateTime(_.get(opts, 'end')),
    'Interval': _.get(opts, 'interval')
  });

  var promise = this._version.fetch({uri: this._uri, method: 'GET', params: data});

  promise = promise.then(function(payload) {
    deferred.resolve(new ImpressionsRateInstance(this._version, payload, this._solution.businessSid));
  }.bind(this));

  promise.catch(function(error) {
    deferred.reject(error);
  });

  if (_.isFunction(callback)) {
    deferred.promise.nodeify(callback);
  }

  return deferred.promise;
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Preview.TrustedComms.BusinessContext.InsightsContext.ImpressionsRateContext#
 *
 * @returns Object
 */
/* jshint ignore:end */
ImpressionsRateContext.prototype.toJSON = function toJSON() {
  return this._solution;
};

ImpressionsRateContext.prototype[util.inspect.custom] = function inspect(depth,
    options) {
  return util.inspect(this.toJSON(), options);
};

module.exports = {
  ImpressionsRateList: ImpressionsRateList,
  ImpressionsRatePage: ImpressionsRatePage,
  ImpressionsRateInstance: ImpressionsRateInstance,
  ImpressionsRateContext: ImpressionsRateContext
};
